import java.util.Random;


public class GameOfLife extends CellularSlide {
	
	private static final long serialVersionUID = 1L;
	static final int ALIVE = 1;
	static final int DEAD = 0;

	public GameOfLife(SlideShow s, CellSpace c) {
		super(s, c);
	}

	@Override
	public void nextstep() {
		int alive, height, width;
		int[][] newspace = new int[cellspace.length][];
		height = cellspace.length;
		width = cellspace[0].length;
		for (int i = 0; i < height; i++){
			
			newspace[i] = new int[width];
			for (int j = 0; j < width; j++){
				alive = 0;
				
				
				if (cellspace[i][(j+1)%width] == ALIVE) alive++; 
				if (cellspace[i][(j-1 + width)%width] == ALIVE) alive++; 
				if (cellspace[(i+1) % height][j] == ALIVE) alive++; 
				if (cellspace[(i-1 + height) % height][j] == ALIVE) alive++;
				
				if (cellspace[(i+1)%height][(j + 1)%width] == ALIVE) alive++; 
				if (cellspace[(i-1 + height)%height][(j-1 + width)%width] == ALIVE) alive++; 
				if (cellspace[(i+1)%height][(j - 1 + width)%width] == ALIVE) alive++; 
				if (cellspace[(i-1 + height)%height][(j + 1)%width] == ALIVE) alive++;
				
				if (alive == 2){
					newspace[i][j] = cellspace[i][j];
				} else if (alive == 3){
					newspace[i][j] = ALIVE;
				} //else DEAD
			}
		}
		
		cellspace = newspace;
	}

	@Override
	public void initCellspace() {
		Random r = new Random();
		for (int i = 0; i < cellspace.length; i++){
			for (int j = 0; j < cellspace[i].length; j++)cellspace[i][j] = r.nextInt(2);
		}
		
	}
	
}
