
public class Growth extends CellularSlide {
	
	static final int ALIVE = 1;
	static final int DEAD = 1;

	private static final long serialVersionUID = 1L;

	public Growth(SlideShow s, CellSpace c) {
		super(s, c);
	}
	
	@Override
	public void nextstep() {
		int count, height, width;
		int[][] newspace = new int[cellspace.length][];
		height = cellspace.length;
		width = cellspace[0].length;
		for (int i = 0; i < height; i++){
			
			newspace[i] = new int[width];
			for (int j = 0; j < width; j++){
				count = 0;
					
				if (cellspace[i][(j+1)%width] == ALIVE) count++; 
				if (cellspace[i][(j-1 + width)%width] == ALIVE) count++; 
				if (cellspace[(i+1) % height][j] == ALIVE) count++; 
				if (cellspace[(i-1 + height) % height][j] == ALIVE) count++;
				
				if (count > 0 || cellspace[i][j] == ALIVE){
					newspace[i][j] = ALIVE;
				} //else DEAD
			}
		}
		
		cellspace = newspace;
	}

	@Override
	public void initCellspace() {
		cellspace[cellspace.length/2][cellspace[0].length/2] = ALIVE;
	}

}
