import java.util.Random;


public class HPPGas extends CellularSlide {

	private static final long serialVersionUID = 1L;
	final static int PARTICLE = 1;
	final static int EMPTY = 0;

	public HPPGas(SlideShow s, CellSpace c) {
		super(s, c);
	}

	@Override
	public void nextstep() {
		int count, i = 0, j = 0, left, right, up, down;
		int[][] newblock = {{0,0},{0,0}};
		if (time%2 == 0){
			i++;
			j++;
		}
		
		for (; i < cellspace.length; i += 2){
			for (; j < cellspace[0].length; j += 2){
				
				count = 0;
				left = j;
				right = (j + 1) % cellspace[0].length;
				up = i;
				down = (i + 1) % cellspace.length;
				
				if (cellspace[up][left] == PARTICLE) count++;
				if (cellspace[up][right] == PARTICLE) count++;
				if (cellspace[down][left] == PARTICLE) count++;
				if (cellspace[down][right] == PARTICLE) count++;
				
				if (count == 2){ //collision (invert) or side-swap
					newblock[0][0] = (cellspace[up][left] + 1) % 2;
					newblock[0][1] = (cellspace[up][right] + 1) % 2;
					newblock[1][0] = (cellspace[down][left] + 1) % 2;
					newblock[1][1] = (cellspace[down][right] + 1) % 2;
				} else { //shift 2 positions
					newblock[0][0] = cellspace[down][right];
					newblock[0][1] = cellspace[down][left];
					newblock[1][0] = cellspace[up][right];
					newblock[1][1] = cellspace[up][left];
				}
				
				cellspace[up][left] = newblock[0][0];
				cellspace[up][right] = newblock[0][1];
				cellspace[down][left] = newblock[1][0];
				cellspace[down][right] = newblock[1][1];
			}
			j = 0;
			if (time%2 == 0) j++;
		}
	}

	@Override
	public void initCellspace() {
	
		Random r = new Random();
		
		for (int i = cellspace.length/2 - 16; i < cellspace.length/2 + 16; i++)
			for (int j = cellspace[0].length/2 - 16; j < cellspace[0].length/2 + 16; j++) cellspace[i][j] = PARTICLE;
	
		for (int i = 0; i < cellspace.length; i++){
			for (int j = 0; j < cellspace[0].length; j++){
				if (r.nextInt(4) == 0) cellspace[i][j] = PARTICLE;
				// else EMPTY
			}
		}
		
		cellspace[cellspace.length/2][cellspace[0].length/2] = PARTICLE;
	}

}
