import java.util.Random;

public class MargolousDemo extends CellularSlide {

	private static final long serialVersionUID = 1L;
	final static int PARTICLE = 1;
	final static int EMPTY = 0;
	
	int phase = 1; //TODO: phase = time + 1;

	public MargolousDemo(SlideShow s, CellSpace c) {
		super(s, c);
	}

	@Override
	public void nextstep() { //SWAP-ON-DIAG ruleset
		int i = 0, j = 0, left, right, up, down;
		int[][] newblock = {{0,0},{0,0}};
		boolean grid;
		
		if (phase == 3){
			i++;
			j++;
		}
		
		if (phase % 2 == 1){
			for (; i < cellspace.length; i += 2){
				for (; j < cellspace[0].length; j += 2){
				
					left = j;
					right = (j + 1) % cellspace[0].length;
					up = i;
					down = (i + 1) % cellspace.length;
				
					newblock[0][0] = cellspace[down][right];
					newblock[0][1] = cellspace[down][left];
					newblock[1][0] = cellspace[up][right];
					newblock[1][1] = cellspace[up][left];
				
					cellspace[up][left] = newblock[0][0];
					cellspace[up][right] = newblock[0][1];
					cellspace[down][left] = newblock[1][0];
					cellspace[down][right] = newblock[1][1];
				}
				
				j = 0;
				if (phase == 3) j++;
			}
		}
		
		for (int m = 0; m < cellspace.length; m++)
			for (int n = 0; n < cellspace[0].length; n++){
				cellspace[m][n] = cellspace[m][n] % 2; // delete coloring
				
				//color
				if (phase / 2 == 0) {
					grid = ((m % 4 < 2) && (n % 4 < 2)) || ((m % 4 >= 2) && (n % 4 >= 2));
				} else {
					grid = ((m % 4 == 1 || m % 4 == 2) && (n % 4 == 1 || n % 4 == 2)) || (!(m % 4 == 1 || m % 4 == 2) && !(n % 4 == 1 || n % 4 == 2));
				}
				if (grid) cellspace[m][n] += 2;
			}	
		
		phase = ++phase % 4;

	}

	@Override
	public void initCellspace() {
		Random r = new Random();
		int x, y;
		
		for (int i = 0; i < 10; i++){
			
			x = r.nextInt(cellspace[0].length);
			y = r.nextInt(cellspace.length);
			
			if (cellspace[y][x] != PARTICLE)
				cellspace[y][x] = PARTICLE;
			else i++;
		}
		
		
		for (int i = 0; i < cellspace.length; i++)
			for (int j = 0; j < cellspace[0].length; j++) if((i % 4) < 2 && (j % 4) < 2 || (i % 4) >= 2 && (j % 4) >= 2 ) cellspace[i][j] += 2;
	}

}
