
public class Parity extends CellularSlide {

	private static final long serialVersionUID = 1L;


	public Parity(SlideShow s, CellSpace c) {
		super(s, c);
	}

	@Override
	public void nextstep() {
		int count, height, width;
		int[][] newspace = new int[cellspace.length][];
		height = cellspace.length;
		width = cellspace[0].length;
		for (int i = 0; i < height; i++){
			
			newspace[i] = new int[width];
			for (int j = 0; j < width; j++){
				count = cellspace[i][j] + cellspace[i][(j+1) % width] + cellspace[i][(j-1 + width) % width] + 
						cellspace[(i+1) % height][j] + cellspace[(i-1 + height) % height][j];
				
				
				newspace[i][j] = count % 2;
			}
		}
		
		cellspace = newspace;
	}


	@Override
	public void initCellspace() {
		cellspace[cellspace.length/2][cellspace[0].length/2] = 1;
		cellspace[cellspace.length/2+1][cellspace[0].length/2] = 1;
		cellspace[cellspace.length/2+1][cellspace[0].length/2+1] = 1;
		cellspace[cellspace.length/2-1][cellspace[0].length/2] = 1;
		cellspace[cellspace.length/2-1][cellspace[0].length/2-1] = 1;
		cellspace[cellspace.length/2][cellspace[0].length/2] = 1;
		cellspace[cellspace.length/2+1][cellspace[0].length/2-1] = 1;
		cellspace[cellspace.length/2-1][cellspace[0].length/2+1] = 1;
		cellspace[cellspace.length/2][cellspace[0].length/2-1] = 1;
		cellspace[cellspace.length/2][cellspace[0].length/2+1] = 1;
	}

}
