
public class ParityScripted extends CellularSlide {

	private static final long serialVersionUID = 1L;
	
	public static final int invx=192, invy=204, inv2x = 204, inv2y = 192;
	
	public static final int INVADER = 1;
	public static final int INVADER2 = 1;
	
	// invx=192, invy=204, inv2x = 204, inv2y = 192 at time 109 looks cool somehow

	public ParityScripted(SlideShow s, CellSpace c) {
		super(s, c);
	}

	@Override
	public void nextstep() {
		int count, height, width;
		int[][] newspace = new int[cellspace.length][];
		height = cellspace.length;
		width = cellspace[0].length;
		for (int i = 0; i < height; i++){
			
			newspace[i] = new int[width];
			for (int j = 0; j < width; j++){
				count = cellspace[i][j] + cellspace[i][(j+1) % width] + cellspace[i][(j-1 + width) % width] + 
						cellspace[(i+1) % height][j] + cellspace[(i-1 + height) % height][j];
				
				
				newspace[i][j] = count % 2;
			}
		}
		
		cellspace = newspace;
	}


	@Override
	public void initCellspace() {
		//invader1
		cellspace[invy][invx+2] = INVADER;
		cellspace[invy][invx+8] = INVADER;
		cellspace[invy+1][invx+3] = INVADER;
		cellspace[invy+1][invx+7] = INVADER;
		cellspace[invy+2][invx+2] = INVADER;
		cellspace[invy+2][invx+3] = INVADER;
		cellspace[invy+2][invx+4] = INVADER;
		cellspace[invy+2][invx+5] = INVADER;
		cellspace[invy+2][invx+6] = INVADER;
		cellspace[invy+2][invx+7] = INVADER;
		cellspace[invy+2][invx+8] = INVADER;
		cellspace[invy+3][invx+1] = INVADER;
		cellspace[invy+3][invx+2] = INVADER;
		cellspace[invy+3][invx+4] = INVADER;
		cellspace[invy+3][invx+5] = INVADER;
		cellspace[invy+3][invx+6] = INVADER;
		cellspace[invy+3][invx+8] = INVADER;
		cellspace[invy+3][invx+9] = INVADER;	
		cellspace[invy+4][invx] = INVADER;	
		cellspace[invy+4][invx+1] = INVADER;
		cellspace[invy+4][invx+2] = INVADER;
		cellspace[invy+4][invx+3] = INVADER;
		cellspace[invy+4][invx+4] = INVADER;
		cellspace[invy+4][invx+5] = INVADER;
		cellspace[invy+4][invx+6] = INVADER;
		cellspace[invy+4][invx+7] = INVADER;
		cellspace[invy+4][invx+8] = INVADER;
		cellspace[invy+4][invx+9] = INVADER;
		cellspace[invy+4][invx+10] = INVADER;	
		cellspace[invy+5][invx+0] = INVADER;
		cellspace[invy+5][invx+2] = INVADER;
		cellspace[invy+5][invx+3] = INVADER;
		cellspace[invy+5][invx+4] = INVADER;
		cellspace[invy+5][invx+5] = INVADER;
		cellspace[invy+5][invx+6] = INVADER;
		cellspace[invy+5][invx+7] = INVADER;
		cellspace[invy+5][invx+8] = INVADER;
		cellspace[invy+5][invx+10] = INVADER;	
		cellspace[invy+6][invx+0] = INVADER;
		cellspace[invy+6][invx+2] = INVADER;
		cellspace[invy+6][invx+8] = INVADER;
		cellspace[invy+6][invx+10] = INVADER;
		cellspace[invy+7][invx+3] = INVADER;
		cellspace[invy+7][invx+4] = INVADER;
		cellspace[invy+7][invx+6] = INVADER;
		cellspace[invy+7][invx+7] = INVADER;
		
		//invader2
		cellspace[inv2y][inv2x+3] = INVADER2;
		cellspace[inv2y][inv2x+4] = INVADER2;
		cellspace[inv2y+1][inv2x+2] = INVADER2;
		cellspace[inv2y+1][inv2x+3] = INVADER2;
		cellspace[inv2y+1][inv2x+4] = INVADER2;
		cellspace[inv2y+1][inv2x+5] = INVADER2;
		cellspace[inv2y+2][inv2x+1] = INVADER2;
		cellspace[inv2y+2][inv2x+2] = INVADER2;
		cellspace[inv2y+2][inv2x+3] = INVADER2;
		cellspace[inv2y+2][inv2x+4] = INVADER2;
		cellspace[inv2y+2][inv2x+5] = INVADER2;
		cellspace[inv2y+2][inv2x+6] = INVADER2;
		cellspace[inv2y+3][inv2x] = INVADER2;
		cellspace[inv2y+3][inv2x+1] = INVADER2;
		cellspace[inv2y+3][inv2x+3] = INVADER2;
		cellspace[inv2y+3][inv2x+4] = INVADER2;
		cellspace[inv2y+3][inv2x+6] = INVADER2;
		cellspace[inv2y+3][inv2x+7] = INVADER2;
		cellspace[inv2y+4][inv2x] = INVADER2;
		cellspace[inv2y+4][inv2x+1] = INVADER2;
		cellspace[inv2y+4][inv2x+2] = INVADER2;
		cellspace[inv2y+4][inv2x+3] = INVADER2;
		cellspace[inv2y+4][inv2x+4] = INVADER2;
		cellspace[inv2y+4][inv2x+5] = INVADER2;
		cellspace[inv2y+4][inv2x+6] = INVADER2;
		cellspace[inv2y+4][inv2x+7] = INVADER2;
		cellspace[inv2y+5][inv2x+2] = INVADER2;
		cellspace[inv2y+5][inv2x+5] = INVADER2;
		cellspace[inv2y+6][inv2x+1] = INVADER2;
		cellspace[inv2y+6][inv2x+3] = INVADER2;
		cellspace[inv2y+6][inv2x+4] = INVADER2;
		cellspace[inv2y+6][inv2x+6] = INVADER2;
		cellspace[inv2y+7][inv2x+2] = INVADER2;
		cellspace[inv2y+7][inv2x+5] = INVADER2;
		cellspace[inv2y+7][inv2x+0] = INVADER2;
		cellspace[inv2y+7][inv2x+7] = INVADER2;
		
	}

}

