import java.util.Arrays;
import java.util.Random;


public class RandomNumber extends CellularSlide {
	
	private static final long serialVersionUID = 1L;
	static final int INACTIVE = 0;
	static final int ZERO = 2;
	static final int ONE = 1;
	static final int rule = (int)2572018122L;
	
	int width, length;

	public RandomNumber(SlideShow s, CellSpace c) {
		super(s, c);
	}

	@Override
	public void nextstep() {
		
		int lookup, row;
		int[][] newspace = new int[length][];
		
		//while( row < cellspace.length && cellspace[row][0] != INACTIVE) row++;
		//row--; //buggy piece of ship
	
		if (time / length == 0) row = time - 1;
		else row = time % length;
		
		//if (row == 0){
			//newspace[0] = cellspace[row];
			//for (int i = 1; i < length; i++) cellspace[i] = new int[width];
			//row = 0;
		//}
		
		if (time / length == 0)
			for (int i = 0; i < length; i++){
				if (row + 1 == i){
					newspace[i] = new int[width];
					for (int j = 0; j < width; j++){
						lookup = 0;
			
						if ((cellspace[row][(j - 2 + width)% width]) == ONE) lookup = lookup + 1<<4;
						if ((cellspace[row][(j - 1 + width)% width]) == ONE )lookup = lookup + 1<<3;
						if ((cellspace[row][j]) == ONE) lookup = lookup + 1<<2;
						if ((cellspace[row][(j + 1) % width]) == ONE) lookup = lookup + 1<<1;
						if ((cellspace[row][(j + 2) % width]) == ONE) lookup = lookup + 1<<0;
			
						if ((1 << lookup & rule) == 0) newspace[row+1][j] = ZERO;
						else newspace[row+1][j] = ONE;
					}
				} else if (i < row + 1) {
					newspace[i] = Arrays.copyOf(cellspace[i], width);
				} else {
					newspace[i] = new int[width];
				}
		}
		else for (int i = 0; i < length; i++){	
				if (row == 0 && i == 0){
					newspace[i] = cellspace[length-1];
				} else if (row == 0 && i == 1){
					newspace[i] = new int[width];
					for (int j = 0; j < width; j++){
						lookup = 0;
						
						if ((newspace[row][(j - 2 + width)% width]) == ONE) lookup = lookup + 1<<4;
						if ((newspace[row][(j - 1 + width)% width]) == ONE )lookup = lookup + 1<<3;
						if ((newspace[row][j]) == ONE) lookup = lookup + 1<<2;
						if ((newspace[row][(j + 1) % width]) == ONE) lookup = lookup + 1<<1;
						if ((newspace[row][(j + 2) % width]) == ONE) lookup = lookup + 1<<0;

						if ((1 << lookup & rule) == 0) newspace[row+1][j] = ZERO;
						else newspace[row+1][j] = ONE;
					}
				} else if (row + 1 == i){
					newspace[i] = new int[width];
					for (int j = 0; j < width; j++){
						lookup = 0;

						if ((cellspace[row][(j - 2 + width)% width]) == ONE) lookup = lookup + 1<<4;
						if ((cellspace[row][(j - 1 + width)% width]) == ONE )lookup = lookup + 1<<3;
						if ((cellspace[row][j]) == ONE) lookup = lookup + 1<<2;
						if ((cellspace[row][(j + 1) % width]) == ONE) lookup = lookup + 1<<1;
						if ((cellspace[row][(j + 2) % width]) == ONE) lookup = lookup + 1<<0;

						if ((1 << lookup & rule) == 0) newspace[row+1][j] = ZERO;
						else newspace[row+1][j] = ONE;
					}
				} else if (i < row + 1) {
					newspace[i] = Arrays.copyOf(cellspace[i], width);
				} else {
					newspace[i] = new int[width];
				}
		}
		
		cellspace = newspace;
	}

	@Override
	public void initCellspace() {
		width = cellspace[0].length;
		length = cellspace.length;
		Random r = new Random();
		for (int i = 0; i < width; i++)cellspace[0][i] = r.nextInt(2) + 1;
		
	}
	
}
