import java.awt.Cursor;
import java.awt.Frame;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import javax.swing.JFrame;

/***
 * @description This is the applications main entry point.
 * 				Contains window settings and starts the slide show in a new thread.
 */
public class SlideShowViewer extends JFrame {
	
	private static final long serialVersionUID = 1L;
	static SlideShowViewer viewer;
	JFrame frame;
	Thread animator;
	
	public SlideShowViewer(){

		setTitle("Slides");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		Toolkit tk = Toolkit.getDefaultToolkit();
		
		BufferedImage cursor = new BufferedImage(16,16,BufferedImage.TYPE_INT_ARGB);
		Cursor transparent = tk.createCustomCursor(cursor, new Point(0,0), "transparent cursor");
		this.setCursor(transparent);
		
		int width = ((int) tk.getScreenSize().getWidth());
		int height = ((int) tk.getScreenSize().getHeight());
		//int width = 1024;
		//int height = 768;
		
		setSize(width, height);
		
		animator = new Thread(new SlideShow(this, width, height));
		animator.start();
		
		setExtendedState(Frame.MAXIMIZED_BOTH);
		setLocationRelativeTo(null);
		setResizable(false);
		setUndecorated(true);
		setVisible(true);
	}
	
	public static void main(String[] args) {
		new SlideShowViewer();	
	}

}
