
import javax.swing.JLabel;
import java.awt.*;
import javax.swing.*;

public class TextSlide extends BasicSlide {
	
	private static final long serialVersionUID = 1L;
	
	final int SIZE, HSIZE;
	final String FONT = "Arial";
	JLabel head, text;
	SpringLayout layout;
	Color color;
	
	public TextSlide(SlideShow s, String h, String t, int c){
		super(s);
		color = new Color(c);
		SIZE = Math.min(s.xsize, s.ysize)/20;
		HSIZE = Math.min(s.xsize, s.ysize)/15;
		//SIZE = Math.min(s.xsize, s.ysize)/24;
		//HSIZE = Math.min(s.xsize, s.ysize)/16;
		layout = new SpringLayout();
		setLayout(layout);

		head = new JLabel(h);
		head.setFont(new Font(FONT, Font.PLAIN, HSIZE));
		head.setForeground(color);
		add(head, BorderLayout.CENTER);
		layout.putConstraint(SpringLayout.NORTH, head, s.ysize/20, SpringLayout.NORTH, this);
		layout.putConstraint(SpringLayout.WEST, head, s.xsize/20, SpringLayout.WEST, this);

		text = new JLabel(t);
		text.setFont(new Font(FONT, Font.PLAIN, SIZE));
		text.setForeground(color);
		add(text,BorderLayout.CENTER);
		layout.putConstraint(SpringLayout.NORTH, text, s.ysize/20, SpringLayout.SOUTH, head);
		layout.putConstraint(SpringLayout.WEST, text, s.xsize/20, SpringLayout.WEST, this);
	}
	
	public TextSlide(SlideShow s, String h, String t){
		this(s,h,t,-1);
	}

	@Override
	public void render(Graphics g) {
	}

	@Override
	public void cycle() {
	}

}
