
public class TimeTunnel extends CellularSlide {

	private static final long serialVersionUID = 1L;


	public TimeTunnel(SlideShow s, CellSpace c) {
		super(s, c);
	}

	@Override
	public void nextstep() {
		int count, height, width;
		int[][] newspace = new int[cellspace.length][];
		height = cellspace.length;
		width = cellspace[0].length;
		for (int i = 0; i < height; i++){
			
			newspace[i] = new int[width];
			for (int j = 0; j < width; j++){
				count = cellspace[i][j] % 2 + cellspace[i][(j+1) % width] % 2 + cellspace[i][(j-1 + width) % width] % 2 + 
						cellspace[(i+1) % height][j] % 2 + cellspace[(i-1 + height) % height][j] % 2;
				
				if (count == 0 || count == 5) count = cellspace[i][j] / 2;
				else count = (cellspace[i][j] / 2 + 1) % 2;
				
				newspace[i][j] = count  + (cellspace[i][j] % 2) * 2;
			}
		}
		
		if (time == 4000) {
			for (int i = 0; i < height; i++){
				for (int j = 0; j < width; j++){
						newspace[i][j] = (newspace[i][j] % 2) * 2 + ( newspace[i][j] / 2);
				}
			}
		
		singlestep = true;
		
		}
		
		if (time == 8000){
			singlestep = true;
		}
		
		cellspace = newspace;
	}


	@Override
	public void initCellspace() {
		cellspace[cellspace.length/2][cellspace[0].length/2] = 3;
		cellspace[cellspace.length/2+1][cellspace[0].length/2] = 3;
		cellspace[cellspace.length/2+1][cellspace[0].length/2+1] = 3;
		cellspace[cellspace.length/2-1][cellspace[0].length/2] = 3;
		cellspace[cellspace.length/2-1][cellspace[0].length/2-1] = 3;
		cellspace[cellspace.length/2][cellspace[0].length/2] = 3;
		cellspace[cellspace.length/2+1][cellspace[0].length/2-1] = 3;
		cellspace[cellspace.length/2-1][cellspace[0].length/2+1] = 3;
		cellspace[cellspace.length/2][cellspace[0].length/2-1] = 3;
		cellspace[cellspace.length/2][cellspace[0].length/2+1] = 3;
	}

}